#!/usr/local/bin/perl

#-----------------------------------------------------------
#(C)A.Yukawa All right reversed.
# 2008.01.01 complete.
#-----------------------------------------------------------

### DATA_FORMAT ###
# Cu
require '../_config/jcode.pl';



#---- tH_ ----

# C[WtH_
$folder_Img = '_db';

#---- CGIt@C ----

# VRg\pCGI
$file_CGI_Index = "index.cgi";

#---- DBt@C ----

# ݃ODB
$file_DB_Log = "_db/db.cgi";

#---- ef[^ ----

# DBtH[}bg
$file_Format_Log = "_library/_format_log.csv";

# LXg&J[
$file_Data_Name  = "_library/_cast.csv";

#---- ̑ ----

# pev[gt@CiXLt@Cj
$file_HTML = "index.html";


### MAIN_WORK ###
# 
&work_Decode;          # DATA DECODE
&work_Search;          # f[^E`
$html .= &html_Layout; # HTML


# \̈
print "Content-type: text/html\n\n";

open (HTML, $file_HTML);
while (<HTML>) {
	if    ($_ =~ '<!-- data -->') { print $html; }
	else                          { print;       }
} close (HTML);

exit;


#---- CAEg
sub html_Layout {
	local ($html);

	$html .= "<div class=diarylog>\n";
	$html .= &html_Log;
	$html .= "</div>\n";

	$html .= "<div class=diarythread>\n";
	$html .= &html_Thread;
	$html .= "</div>\n";

	return ($html);
}


#---- Xbh\
sub html_Thread {
	local ($html);

	$html .= "<p class=archive>A[JCuX</p>\n";
	$html .= "<ul>\n";

	foreach (sort {$b <=> $a} keys %day) {
		# ttH[}bg
		local ($y, $m) = &work_Date($_);
		$html .= "<li><a href=\"$file_CGI_Pro?d=$_\">$yN$mi$day{$_}j</a></li>\n";
	}

	$html .= "</ul>\n";
	return ($html);
}


#---- O\
sub html_Log {
	local ($html, %l, $flag = 0);

	foreach (@db) {
		# tH[}bgɊU
		local (@d) = split(/,/);
		for $n (0 .. @format_Log - 1) { $l{@format_Log[$n]} = @d[$n]; }

		# LXgI
		local ($name, $tag) = split(/,/, $cast{$l{'cast'}});

		# ttH[}bg
		local ($y, $m, $d, $h) = &work_Date($l{'day'});

		# s
		$l{'comment'} =~ s/>/<br>/g;

		# s
		$l{'comment'} =~ s/&gt;/&gt;\n/g;

		# 摜\
		$l{'comment'} =~ s/(&lt;)([a-zA-Z\d\.\/\-+#_?~&%=^\@:;()]+.(jpg|gif))(&gt;)/<div class=img><img src="$folder_Img\/$2" border=1><\/div>/g;

		# RgtURLN
		$l{'comment'} =~ s/(http:\/\/[a-zA-Z\d\.\/\-+#_?~&%=^\@:;()]+)(&lt;){1}(.+)(&gt;){1}/<a href="$1" target=_blank>$3<\/a>/g;

		# URLN
		$l{'comment'} =~ s/([^=^\"]|^)(http:\/\/[a-zA-Z\d\.\/\-+#_?~&%=^\@:;()]+)/$1<a href="$2" target=_blank>$2<\/a>/g;

		# eIWi^O
		$l{'comment'} =~ s/&lt;(b\/)(.+)&gt;/<b>$2<\/b>/g;
		$l{'comment'} =~ s/&lt;(cl\/)(.+)&gt;/<s>$2<\/s>/g;
		$l{'comment'} =~ s/&lt;(s\/)(.+)&gt;/<span class=f11>$2<\/span>/g;
		$l{'comment'} =~ s/&lt;(l\/)(.+)&gt;/<span class=f16>$2<\/span>/g;

		# s
		$l{'comment'} =~ s/\n//g;

		$html .= "<p class=bar$tag>$yN$m$d $name</p>\n";
		$html .= "<p class=title$tag>$l{'title'}</p>\n";
		$html .= "$l{'comment'}\n";
		$html .= "<br class=clear /><br />\n";
	}

	return ($html);
}


#---- f[^E`
sub work_Search {

	# tH[}bgǂݍ -- <@format_Log>
	local ($flag = 0);
	open (in, $file_Format_Log);
	while (<in>) {
		$_ =~ s/(\r\n|\r|\n)//g;
		local (@d) = split(/,/);
		push @format_Log, @d[1];
		@sort[0] = $flag + 1 if (@d[1] eq 'day');
		@sort[1] = $flag + 1 if (@d[1] eq 'name');
		$flag ++;
	} close (in);

	# LXgf[^ǂݍ -- <%cast>
	open (in, $file_Data_Name);
	while (<in>) {
		$_ =~ s/(\r\n|\r|\n)//g;
		local (@d) = split(/,/);
		$cast{@d[0]} = "@d[1],@d[2],";
	} close (in);

	# ODB ǂݍ -- <@db>
	local (%l, $flag = 0);
	open (in, $file_DB_Log);
	while (<in>) {
		# tH[}bgɊU
		local (@d) = split(/,/);
		for $n (0 .. @format_Log - 1) { $l{@format_Log[$n]} = @d[$n]; }

		next if (!$l{'flag'});

		# tA[JCu
		$day{substr($l{'day'}, 0, 4)} ++;


		# EU蕪 ----

		# $d{'d'} tw肪ꍇ U蕪
		next if ($d{'d'} && $d{'d'} != substr($l{'day'}, 0, 4));

		# $d{'d'} tw肪Ȃꍇ 10\
		if (!$d{'d'} && $flag > 5) { next; } else { $flag ++; }

		push @db, $_;
	}
	close (in);


	# tw肪ꍇ͋tɃ\[g
	@db = map {$_->[0]} sort {$a->[@sort[0]] <=> $b->[@sort[0]] or $a->[@sort[1]] <=> $b->[@sort[1]]} map {[$_, split /,/]} @db if ($d{'d'});
}


#---- t\tH[}bgNb
sub work_Date {
	local ($y, $m, $d, $h, $i, $s);
	$y = int(substr($_[0],  0, 2));
	$m = int(substr($_[0],  2, 2));
	$d = int(substr($_[0],  4, 2));
	$h = int(substr($_[0],  6, 2));
	$i = int(substr($_[0],  8, 2));
	$s = int(substr($_[0], 10, 2));

	return($y + 2000, $m, $d, $h, $i, $s);
}


#---- DATA DECODE
sub work_Decode {
	# t^Ԃo
	$ENV{'TZ'} = "JST-9";
	($setS, $setI, $setH, $setD, $setM, $setY) = (localtime(time))[0..5];

	$setY += 1900;
	$setM ++;

	# ̓tE
	$d{'date'}  = sprintf("%02d%02d%02d%02d%02d%02d", $setY - 2000, $setM, $setD, $setH, $setI, $setS);

	# j̔z
	@week = ("", "", "", "", "", "", "y");

	# f[^o
	if ($ENV{'REQUEST_METHOD'} eq 'POST') { read(STDIN, $Buffer, $ENV{'CONTENT_LENGTH'}); }
	else { $Buffer = $ENV{'QUERY_STRING'}; }

	foreach (split (/&/, $Buffer)) {
		local ($n, $v) = split(/=/);
		$n =~ tr/+/ /; $n =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$v =~ tr/+/ /; $v =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

		jcode::h2z_sjis(\$v);
		jcode::tr(\$v, ',\\', 'C');
		jcode::convert(\$v, 'sjis');

		$d{$n} = $v;
	}
}

# EOF
